//Chris Busch
//pbm to ti85 asm converter
//This quickly written program can convert .pbm files to
//.asm files for use by your zshell programs.
//If you would like to compress your .asm files using ezcmp.exe,
//compile your picture.asm file to picture.obj (an .END must be placed
//at the end of the picture.asm file) using tasm.  With the picture.obj
//file run ezcmp.exe like:
//   ezcmp picture.obj picezcmp.asm
////////////////////
/////FYI: The excellent shareware paint program for Windows, 
/////Paint Shop Pro, can produce .PBM files.


#include <stdio.h>
#include <string.h>

FILE* in;
int count=0;

int tankflag=0;

void main(int argc,char** args)
{
   fprintf(stderr,"\tPBM2TI85 ASM Converter\n"
      "Takes .PBM (portable bit map) graphic files and converts\n"
      "them to .asm files.\nSyntax: pbm2ti85 > output.asm\n"
      "Last compiled: " __DATE__ " " __TIME__"\n"
      "Press Control-Z and ENTER to stop.\n");
   if(argc==2 && stricmp(args[1],"t") == 0 ) {
      tankflag = 1; fprintf(stderr,"Extended output on.\n");
   }
	puts(";;pbm converter");
   char input[100];
	while((fprintf(stderr,"Input PBM file name to convert:"),fgets(input,100,stdin))) {
		int len=strlen(input);
      if(len>1) {
	input[len-1]=0;
	 printf(";;picture '%s'\n",input);
			if( (in=fopen(input,"rt"))!=NULL ) {
	    char name[20];
	    int i;
	    for(i=0;input[i]!='.' && i<8;i++) { name[i]=input[i]; }
	    name[i]=0;  //get name from filename
	    if(tankflag) printf("%stype  =%d\n",name,count++);
	    printf("actor%s:\n",name);
		char line[100];
	    fgets(line,100,in);
	    if(strnicmp(line,"P1",2) != 0 ) fprintf(stderr,"Input file might not be of correct type.\n");
	    fputs(line,stderr);  //should be P1
	    fgets(line,100,in);
	    fputs(line,stderr);  //comment string
	    if(tankflag) printf("   .db %stype   ;type\n",name);
	    int xsize,ysize;
	    fscanf(in,"%d",&xsize);
	    fscanf(in,"%d",&ysize);
	    printf("%s   .db %d,%d,%d ;xsize,xbytes,ylines\n",
		tankflag ? "":";;;;",xsize,xsize/8 + (xsize % 8 != 0 ),ysize);
	    int x,y,digit;
	    for(y=0;y<ysize;y++) {
		printf("   .db ");
		for(x=0;x<xsize;x++) {
		  if(x>0 && x%8==0) printf("b, ");
						fscanf(in,"%d",&digit);
		  printf("%d",digit);
	       }
	       if(x%8!=0) {
		while(x%8!=0) { printf("0"); x++; }
		  printf("b");
	       }else printf("b");
	       puts("");
	    }
	    fclose(in);
	    printf(";;end '%s'\n",input);
			}else{
		printf(";;could not open '%s'\n",input);
	      }
      }
	}
   puts(";;end pbm converter");
}
